﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.Events;

namespace ColumnWidthIssue
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            dataGrid.FieldLayoutSettings.AutoGenerateFields = false;
            dataGrid.FieldLayoutInitialized += OnFieldLayoutInitialized;

            var persons = new List<Person>();
            for (int i = 0; i < 100; i++)
            {
                persons.Add(new Person
                {
                    Name = "Name " + i,
                    Address = "Street " + i
                });
            }

            dataGrid.DataSource = persons;
        }

        private void OnFieldLayoutInitialized(object sender, FieldLayoutInitializedEventArgs e)
        {
            var field = new Field
            {
                Label = "Name",
                Name = "Name"
            };
            e.FieldLayout.Fields.Add(field);

            field = new Field
            {
                Label = "Address",
                Name = "Address",
                Settings = new FieldSettings
                {
                    AllowRecordFiltering = true,
                    EditorType = typeof(AddressEditor)
                }
            };
            e.FieldLayout.Fields.Add(field);
        }
    }

    public class Person
    {
        public string Name { get; set; }

        public string Address { get; set; }
    }
}
